/* Copyright (C) 2010-2011 Linaro Ltd.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/*
 * Authors:
 *  Jammy Zhou <jammy.zhou@linaro.org>
 *  Marc Ordinas i Llopis, Collabora Ltd <marc.ordinasillopis@linaro.org>
 */

#define LIBEGL_PATH     "/usr/lib/libEGL.so"

typedef unsigned int EGLBoolean;
typedef unsigned int EGLenum;
typedef int EGLint;
typedef void *EGLConfig;
typedef void *EGLContext;
typedef void *EGLDisplay;
typedef void *EGLSurface;
typedef void *EGLNativeDisplayType;
typedef unsigned int EGLNativeWindowType;

#define EGL_NO_DISPLAY   ((EGLDisplay)0)
#define EGL_NO_CONTEXT   ((EGLContext)0)
#define EGL_NO_SURFACE   ((EGLSurface)0)

/* QueryString targets */
#define EGL_VENDOR          0x3053
#define EGL_VERSION         0x3054
#define EGL_EXTENSIONS          0x3055
#define EGL_CLIENT_APIS         0x308D

#define EGL_OPENGL_ES_API 0x30A0
#define EGL_OPENGL_API    0x30A2

#define EGL_RENDERABLE_TYPE             0x3040
#define EGL_SURFACE_TYPE                0x3033
#define EGL_PBUFFER_BIT                 0x0001  /* EGL_SURFACE_TYPE mask bits */
#define EGL_OPENGL_ES2_BIT              0x0004  /* EGL_RENDERABLE_TYPE mask bits */
#define EGL_CONTEXT_CLIENT_VERSION      0x3098
#define EGL_NONE                        0x3038
#define EGL_HEIGHT                      0x3056
#define EGL_WIDTH                       0x3057

typedef void * (*PFNPROXYEGLGETPROCADDRESSPROC)( char const *procName);
typedef char const * (*PFNPROXYEGLQUERYSTRINGPROC)(EGLDisplay display, EGLint name);
typedef EGLDisplay (*PFNPROXYEGLGETDISPLAYPROC)(EGLNativeDisplayType display_id);
typedef EGLBoolean (*PFNPROXYEGLINITIALIZEPROC)(EGLDisplay dpy, EGLint *major, EGLint *minor);
typedef EGLBoolean (*PFNPROXYEGLTERMINATEPROC)(EGLDisplay dpy);
typedef EGLBoolean (*PFNPROXYEGLCHOOSECONFIGPROC)(EGLDisplay dpy, const EGLint *attrib_list, EGLConfig *configs, EGLint config_size, EGLint *num_config);
typedef EGLSurface (*PFNPROXYEGLCREATEPBUFFERSURFACEPROC)(EGLDisplay dpy, EGLConfig config, const EGLint *attrib_list);
typedef EGLBoolean (*PFNPROXYEGLDESTROYSURFACEPROC)(EGLDisplay dpy, EGLSurface surface);
typedef EGLContext (*PFNPROXYEGLCREATECONTEXTPROC)(EGLDisplay dpy, EGLConfig config, EGLContext share_context, const EGLint *attrib_list);
typedef EGLBoolean (*PFNPROXYEGLDESTROYCONTEXTPROC)(EGLDisplay dpy, EGLContext ctx);
typedef EGLBoolean (*PFNPROXYEGLMAKECURRENTPROC)(EGLDisplay dpy, EGLSurface draw, EGLSurface read, EGLContext ctx);
